# !/bin/sh
# script to roll back a failed update site promote

##########################################################################################
if [ $# -lt 1 ]; then
	echo " "
	echo "usage: ${0##*/} <dir> <dir2> <dir3>"
	echo " "
	echo "Example:"
	echo "     ${0##*/} \\"
	echo "         /var/www/html/modeling/emft/updates/milestones/emft-net4j-0.8-S \\"
	echo "         /var/www/html/modeling/emft/updates/milestones/emft-cdo-0.8-S"
	echo " "
	exit 1
fi

# Create local variable based on the input
dirs="";
while [ "$#" -gt 0 ]; do
	case $1 in
		*) dirs=$dirs" "$1; shift 1;;
	esac
done

for d in $dirs; do
	site=${d%/*};
	targ=${d##*/};
	echo "Rolling back ${targ}_* in $site ...";
	pushd $site >/dev/null;
	rm -fr ${targ}_r0;
	if [[ -d ${targ}_r1 ]]; then mv ${targ}_r1 ${targ}_r0; fi
	if [[ -d ${targ}_r2 ]]; then mv ${targ}_r2 ${targ}_r1; fi
	popd >/dev/null;
done

#echo "[update] ${0##*/} completed on: `date +%Y%m%d\ %H\:%M\:%S`"
echo ""; 
