# !/bin/sh
# script to generate multiple update sites from a file tree

##########################################################################################
if [ $# -lt 1 ]; then
	echo " "
	echo "usage: ${0##*/} <buildUpdateSite.sh options> <dir> <dir2> <dir3>"
	echo " "
	echo "Example:"
	echo "     ${0##*/} -debug 1 -coordsite ganymede -promote \\"
	echo "         /home/www-data/build/modeling/emf/emf/ \\"
	echo "         /home/www-data/build/modeling/emf/query/ \\"
	echo "         /home/www-data/build/modeling/mdt/"
	echo " "
	exit 1
fi

# Create local variable based on the input
dirs="";
while [ "$#" -gt 0 ]; do
	case $1 in
		'-debug'|'-coordsite') options=$options" $1 $2"; shift 2;;
		'-promote'|'-noclean') options=$options" $1"; shift 1;;
		*) dirs=$dirs" "$1; shift 1;;
	esac
done

function runCmd ()
{
	b=$1;
	buildID=${b##*/};
	branch=${b%/$buildID}; branch=${branch##*/};
	sub=${b%/downloads/drops/$branch/$buildID}; sub=${sub##*/};
	#echo "";
	#echo "           ** $sub / $branch / $buildID **"
	#echo "";
	cmd="${0%/*}/buildUpdateSite.sh -sub $sub -branch $branch -buildID $buildID -catgXMLOnly -Q $options"; 
	echo $cmd; $cmd;
}
for d in $dirs; do
	#echo "[update] Searching for builds in $d:"
	d=$(cd $d; pwd); 
	for dd in $(find $d -maxdepth 2 -type d -regex ".*/[MISR]20[0-1][0-9]+"|sort); do 
		runCmd $dd;
	done	
	for dd in $(find $d -maxdepth 3 -type d -regex ".*/drops"|sort); do
		for b in $(find $dd -maxdepth 2 -type d -regex ".*/[MISR]20[0-1][0-9]+"|sort); do
			runCmd $b
		done
	done
done
#echo "[update] ${0##*/} completed on: `date +%Y%m%d\ %H\:%M\:%S`"
echo ""; 
