#!/bin/bash
# use this to extract the latest stable tag of basebuilder into /home/www-data/build, /opt/public/modeling/build, or user-def'd dir
# for latest tag, see: http://wiki.eclipse.org/Platform-releng-basebuilder

usage ()
{
	echo "Usage: ${0} RC2_34 [/path/to/target/dir]";
	exit;
}

if [[ $# -lt 1 ]]; then usage; fi

tag=$1; shift;
dir="";
if [[ $# -gt 0 ]]; then
	dir=$1; shift;
fi
if [[ ! $dir ]]; then
	if [[ -d /home/www-data/build ]]; then
		dir=/home/www-data/build
	elif [[ -d /opt/public/modeling/build ]]; then
		dir=/opt/public/modeling/build
	fi
fi
if [[ ! $dir ]]; then usage; fi
 
pushd $dir >/dev/null;
echo "Exporting org.eclipse.releng.basebuilder from tag $tag ...";
cvs -d :pserver:anonymous@dev.eclipse.org:/cvsroot/eclipse -Q ex -r \
	${tag} -d org.eclipse.releng.basebuilder_${tag} org.eclipse.releng.basebuilder;
echo "Replacing symlink ...";
rm -f org.eclipse.releng.basebuilder;
ln -s org.eclipse.releng.basebuilder_${tag} org.eclipse.releng.basebuilder;

popd >/dev/null;