#!/bin/bash

# used by CreateMapFile and CreateTestManifestFile tasks

srcdir="";
outfile="";
projectName="";
subprojectName="";
out=""

# Create local variable based on the input
while [ "$#" -gt 0 ]; do
	case $1 in
		'-proj')   projectName=$2; shift 1;;
		'-sub') subprojectName=$2; shift 1;;
		'-I')           srcdir=$2; shift 1;;
		'-O')          outfile=$2; shift 1;;
	esac
	shift 1
done

cd $srcdir;
for f in $(find org.eclipse.$projectName/org.eclipse.$subprojectName -maxdepth 3 -name "META-INF" -o -name "feature.xml" -o -name "fragment.xml" | grep -v "deprecated" | sort);
do
	folder=${f%/*}; folder=${folder#./};
	type=${f##*/};
	if [[ $type = "fragment.xml" ]]; then
		out="$out $folder-fragment"
	else
		out="$out $folder"
	fi;
done

out=${out# }

echo "#properties used by CreateMapFile and CreateTestManifestFile tasks" > $outfile;
echo "directories="$out >> $outfile;

