#!/bin/sh

if [[ $# -lt 2 ]]; then
  echo "Usage:    ${0##*/} <filename> <propertyName> [variable=substitution] [variable2=substitution2] ";
  echo "Example1: ${0##*/} server.properties JAVA_HOME"; 
  echo "Example2: ${0##*/} \$buildcfg downloadsDir writableBuildRoot=\$writableBuildRoot"; 
  exit 1;
fi

file=$1
property=$2
shift 2
result=$(grep $property $file | egrep -v "^#" | grep "$property=" | head -1 | sed -e "s/$property=//")
while [[ $# -gt 0 ]]; do
	pair=$1;
	label=$pair; label=${label%%=*}; # trim from the = to the end 
	value=$pair; value=${value##*=};  # trim up to the =
	result=${result//\$\{$label\}/$value}; # replace ${foo} with bar (all occurences)
	shift 1;
done
echo $result