<?php
/*
script to deliver any queued mail to users alerting them that their build is ready.

php -q /home/www-data/modeling/scripts/sendEmail.php
    -email nickboldt@gmail.com
  	-proj emft
  	-sub cdo
	-branch 2.1.0
	-buildID R200507070200
(optionally, for a promote email)
	-promote true
*/

ini_set('display_errors', 1); ini_set('error_reporting', E_ALL);

$mailEnabled = 1;

$buildServerDefault = "emft.eclipse.org";
$promoServerDefault = "download.eclipse.org";

/* ******************************************************************************* */

// shouldn't have to change anything below here.

$date = date('H:i');

$args = getPairs(); //wArr($args); // get cmdline options
$args["parent"] = isset($args["parent"]) ? $args["parent"] : "";
$server = array_key_exists("hostname", $args) ? $args["hostname"] : getServerName();
$debug = array_key_exists("debug", $args) ? $args["debug"] : 0;
$email = array_key_exists("email", $args) ? $args["email"] : "";

$parent = array_key_exists("parent", $args) ? ($args["parent"] == "NONE" ? "" : $args["parent"]) : "modeling";
$projectName = array_key_exists("proj", $args) ? $args["proj"] : "";
$projectName2 = "";
$subprojectName = array_key_exists("sub", $args) ? $args["sub"] : "";

$version = array_key_exists("version", $args) ? $args["version"] : (array_key_exists("branch", $args) ? $args["branch"] : "");
$buildID = array_key_exists("buildID", $args) ? $args["buildID"] : "";

$promote = array_key_exists("promote", $args) ? $args["promote"] : "";
$test = array_key_exists("test", $args) ? $args["test"] : "";
$branch = array_key_exists("branch", $args) ? $args["branch"] : "";

$buildStatus = array_key_exists("buildStatus", $args) ? $args["buildStatus"] : "";

$label = $projectName != $subprojectName ? strtoupper("$projectName $subprojectName") : strtoupper($subprojectName);
if ($email)
{
	if ($buildStatus)
	{
		$buildStatusArray = array($buildStatus."\n","\n");
	}
	else
	{
		$checkBuildStatusURL = "http://" . $server . "/modeling/build/checkBuildStatus.php?parent=$parent&top=$projectName&project=$subprojectName&version=$version&buildID=" . substr($buildID,0,13);
		echo "[send] Checking build status from $checkBuildStatusURL ...\n";
		$buildStatusArray = file($checkBuildStatusURL);
		$buildStatus = explode("\t", $buildStatusArray[0]);
		$buildStatus = isset($buildStatus[1]) ? trim($buildStatus[1]) : "";
		if ($debug)
		{
			echo "[send] Got status: $buildStatus.\n";
		}

		# special case for emft
		if (strpos($buildStatus, "UNKNOWN") !== false && $projectName == "emf")
		{
			$projectName2 = "emft";
			$checkBuildStatusURL = "http://" . $server . "/modeling/build/checkBuildStatus.php?parent=" . ($args["parent"] == "NONE" ? "NONE" : $parent) .
				"&top=$projectName2&project=$subprojectName&version=$version&buildID=" . substr($buildID,0,13);
			echo "[send] Checking build status from $checkBuildStatusURL ...\n";
			$buildStatusArray = file($checkBuildStatusURL);
			$buildStatus = explode("\t", $buildStatusArray[0]);
			$buildStatus = trim($buildStatus[1]);
			if ($debug)
			{
				echo "[send] Got status(2): $buildStatus.\n";
			}
			if (strpos($buildStatus, "UNKNOWN") === false)
			{
				$projectName = $projectName2; # use emft instead of emf
			}
		}
	}

	if ($projectName == "updateSearchCVS")
	{
		$subject = "Search CVS updated [$date]";
		$body = str_replace("%20"," ",str_replace("%0A","\n",str_replace("&amp;","&",str_replace("\t",":\n",implode("",$buildStatusArray)))));
	}
	else
	{
		$subject = "[$buildStatus] " . trim($label) . " " .
			($test ? $test . " Test" : ($branch ? $branch . " " : "") . "Build") . " " .
			($version ? "$version / " : "") . (strpos($buildID,"/")!==false ? str_replace("/"," / ",$buildID) : $buildID) . " " .
			($promote ? "promoted to download.eclipse.org" : "done") . " [$date]";
		$body = str_replace("&amp;","&",str_replace("\t",":\n",implode("",$buildStatusArray)));
	}
	$body .= isset($checkBuildStatusURL) && $checkBuildStatusURL ? "Status Check:\n" . $checkBuildStatusURL . "\n" : "";
	echo "[send] Sending mail from $server ...\n";
	$ret = sendMail($subject, $body, $buildStatus);
	echo $ret;
}
else
{
	echo "[send] Nothing to do! No email address(es) found.\n";
}

if ($debug || $email)
{
	echo '[send] Mail delivery completed ' . date('\a\t h:i:sa') . "\n\n";
}

/* ******************************************************************************* */

// methods

function getPairs()
{ // collect cmdline options in -foo bar -baz foobar into array: $args["foo"]="bar", etc.
	ini_set("display_errors", "0"); // suppress file not found errors
	global $_SERVER;
	$argv = $_SERVER["argv"];
	$args = array ();
	if (!is_array($argv) || sizeof($argv) < 2)
	{
		echo "[send] No commandline params specified! Exiting...\n";
		return array ();
	}
	else
	{
		for ($i = 1; $i < sizeof($argv); $i += 2)
		{ // skip $i=0, that's the script name
			if (array_key_exists($i +1, $argv))
			{
				$args[substr($argv[$i], 1)] = $argv[$i +1] . "";
			}
		}
	}
	ini_set("display_errors", "1"); // and turn 'em back on.
	return $args;
}

function sendMail($subject, $body, $buildStatus)
{
	global $debug, $email, $label, $mailEnabled, $server;

	#$body = wordwrap($body, 70, "\n", true); /* split long lines */

	$pref = "[mail] ";

	$retString = "";

	#$sender = "build.monkey@$server";
	$sender = "nickboldt@gmail.com";
	$senderN = $label ." Build Team";

	/* headers */
	$headers = "Content-Type: text/plain;\n";
	$headers .= "Reply-To: \"$senderN\" <" . $sender . ">\n";
	$headers .= "From: \"$senderN\" <" . $sender . ">\n";

	if (strpos($buildStatus, "FAIL") !== false || strpos($buildStatus, "UNKNOWN") !== false)
	{
		# mark urgent
		if ($debug)
		{
			print "[mail] Set email to priority 1 (highest / High)\n";
		}
		$headers .= "X-Priority: 1 (highest)\n";
		$headers .= "X-MSMail-Priority: High\n";
		$headers .= "Importance: High\n";
	}
	
	/* recipient(s) */
	$to = $email;

	/* and now mail it */
	$retString = ($debug ? $pref . "Sending email to $to ... \n" : "");
	if ($debug)
	{
		$retString .= $pref . "Subject: $subject\n";
		$retString .= $pref . "Body: $body\n";
		//w($retString);
	}
	if ($mailEnabled)
	{
		ini_set("sendmail_from", $sender);
		$ret = mail($to, $subject, $body, $headers, '-f' . $sender);
		$retString .= $pref . ($ret ? "Success!\n" : "Failed!\nCould not send the email\n");
	}
	else
	{
		$retString .= $pref . ("Email delivery disabled by script (mailEnabled=false).\n");
	}
	return $retString . "\n";
}

function getServerName()
{
	global $_SERVER, $SERVER_NAME;
	$s = "";
	if ($SERVER_NAME)
	{
		return $SERVER_NAME;
	}
	else
	{
		exec("cd /; hostname -f",$s);
		$s = is_array($s) && sizeof($s) > 0 ? $s[0] : "";
	}
	return $s;
}
?>