# !/bin/sh

#Min Hr Mday Month Wday Cmd
# U/O/QTV N builds: uml2 (20-25), ocl (10-15), query (5-10), validation (7-10), transaction (12-15)
#00 18 * * 2 sudo -u www-data /home/www-data/build/modeling/scripts/start_cron.sh -sub uml2 -regex "[ISR]200.*/eclipse-SDK-|[ISR]200.*/emf-sdo-xsd-SDK-" -basebuilderBranch v20071030 -n -a > $HOME/cron_logs/start_cron.sh.uml2.N.txt 2>&1
#25 18 * * 2 sudo -u www-data /home/www-data/build/modeling/scripts/start_cron.sh -sub ocl -regex "[ISR]200.*/eclipse-SDK-|[ISR]200.*/emf-sdo-xsd-SDK-|[ISR]200.*/mdt-uml2-SDK|orbit" -basebuilderBranch v20071030 -n -a > $HOME/cron_logs/start_cron.sh.ocl.N.txt 2>&1
#40 18 * * 2 sudo -u www-data /home/www-data/build/modeling/scripts/start_cron.sh -sub query -regex "[ISR]200.*/eclipse-SDK-|[ISR]200.*/emf-sdo-xsd-SDK-|[S]200.*mdt-ocl-SDK-" -basebuilderBranch v20071030 -n > $HOME/cron_logs/start_cron.sh.query.N.txt 2>&1
#50 18 * * 2 sudo -u www-data /home/www-data/build/modeling/scripts/start_cron.sh -sub validation -regex "[ISR]200.*/eclipse-SDK-|[ISR]200.*emf-sdo-xsd-SDK-|[S]200.*mdt-ocl-SDK-" -basebuilderBranch v20071030 -n -a > $HOME/cron_logs/start_cron.sh.validation.N.txt 2>&1
#00 19 * * 2 sudo -u www-data /home/www-data/build/modeling/scripts/start_cron.sh -sub transaction -regex "[ISR]200.*/eclipse-SDK-|[ISR]200.*/emf-sdo-xsd-SDK-|[ISR]200.*/emf-validation-SDK-" -basebuilderBranch v20071030 -nosearchcvs > $HOME/cron_logs/start_cron.sh.transaction.N.txt 2>&1

###### ###### ###### ###### ###### ###### INSTRUCTIONS & OPTIONS ###### ###### ###### ###### ###### ###### 

norm="\033[0;39m";
grey="\033[1;30m";
green="\033[1;32m";
brown="\033[0;33m";
yellow="\033[1;33m";
blue="\033[1;34m";
cyan="\033[1;36m";
red="\033[1;31m";

function usage()
{
	echo "usage: $0"
	echo -e "$red-sub$norm               <REQUIRED: MUST BE FIRST FLAG; if ./promoteToEclipse.${red}sub$norm.properties not found, try ./promoteToEclipse.properties>"
	echo -e "$brown-deps$norm              <REQUIRED (if not using $brown-regex$norm): comma-separated list to match when searching dependencies file for requirements" 
	echo "                    eg., eclipse,emf,ocl >"
	echo -e "$brown-regex$norm             <REQUIRED (if not using $brown-deps$norm): regular expression to match when searching dependencies file for requirements,"
	echo "                    eg., \"eclipse-.*I|emf-.*I|ocl-.*I\" >"
	echo ""
	echo -e "-d, -URL           <optional: list of ${yellow}type${norm}=${yellow}URL${norm} pairs for hardcoding dependencies, if you want to build with something older than"
	echo -e "                    the latest in the list). Enter one -d [...] per required ${yellow}type${norm}=${yellow}URL${norm} pair, "
	echo -e "                    eg., -d ${yellow}emf${norm}=${yellow}http://archive.eclipse.org/modeling/emf/emf/downloads/drops/2.3.0/R200706262000/emf-sdo-xsd-SDK-2.3.0.zip${norm} >"
	echo "-a, -addSDK        <optional: if used, add the resulting SDK zip to the dependencies file for use with other builds>"
	echo "-l, -listDeps      <optional: if used, list the contents of the dependencies file instead of running a build>"
	echo ""
	echo "-buildType         <optional: the type of the build - N, I, S, M, R (default: N)>"
	echo "-cvsbranch         <optional: define the CVS branch to build, eg., R2_0_maintenance or HEAD (default: HEAD)>"
	echo "-buildAlias        <optional: the Alias of the build, eg. 2.0.6>"
	echo "-javaHome          <optional; defaults to value in _common.php file>"
	echo "-basebuilderBranch <optional: CVS branch of org.eclipse.releng.basebuilder; (defaults to value in _common.php file))>"
	echo "-projRelengRoot    <optional: CVS root of project's releng module; (defaults to value in _common.php file))>"
	echo -e "-projRelengBranch  <optional: CVS branch of org.eclipse.${red}sub$norm.releng>"
	echo -e "-s, -searchCVS     <optional: comma-separated list of CVS modules to check for updates; defaults to ${red}proj$norm.${red}sub$norm, eg., mdt.ocl or emft.search,"
	echo "                    which expands to org.eclipse.mdt/org.eclipse.ocl or org.eclipse.emf/org.eclipse.emf.search>"
	echo "-n, -noSearchCVS   <optional: don't check Search CVS for updates before running a build>"
	echo "    -days          <optional: set number of days of CVS to check; ignored if -n used (default: 1 for N builds, 7 for others)>" 
	echo "-p, -preview       <optional: don't actually run a build, just echo the command for preview>"
	echo "-O, -depsOnly      <optional: don't actually run a build, just echo the list of deps found; "
	echo -e "                              if used with no $brown-regex$norm or $brown-deps$norm, will attempt to get regex from subproject's "
	echo "                              www/modeling/\$projectName/\$subprojectName/build/_common.php file>"
	echo ""
	exit 1
}

if [ $# -lt 1 ]; then
	usage;
fi

# different default paths for build.eclipse.org vs. emf.toro/emft.eclipse
writableBuildRoot=/home/www-data; if [[ ! -d $writableBuildRoot ]]; then writableBuildRoot=/opt/public/modeling; fi  
webRoot=/var/www/html; if [[ ! -d $webRoot ]]; then webRoot=/opt/public/modeling/public_html/; fi

#defaults
depsFile=$writableBuildRoot/build/requests/dependencies.urls.txt;
buildType="N"
projectName="";
subprojectName="";
cvsbranch="HEAD";
searchCVSModules="";
nosearchcvs=0;
preview=0;
debug=0;
javaHomeOverride="";
addSDK="";
args="";
depsOnly=0;

# make sure we're in the scripts folder so properties files will resolve
scriptsdir=$0; scriptsdir=${scriptsdir%/*}; cd $scriptsdir;

function debug() # $3 can be set to "-n" 
{
	thresh=0;
	if [[ $2 -gt 0 ]]; then thresh=$2; fi
	if [[ $debug -gt $thresh ]]; then echo -e $3 "$1"; fi
} 
	
function loadCVSPropertiesFile()
{
	# Input: org.eclipse.emf/org.eclipse.emf.query.releng/promoteToEclipse.query.properties,R1_1_maintenance
	tmp=`mktemp -d`; tmp=${tmp#/tmp/};
	in=$1;
	if [[ ${in##*,*} ]]; then in=$in,HEAD; fi # default branch is HEAD
	cvsPropertiesPath=$in; cvsPropertiesPath=${cvsPropertiesPath%,*}; # org.eclipse.emf/org.eclipse.emf.query.releng/promoteToEclipse.query.properties
	cvsPropertiesBranch=$in; cvsPropertiesBranch=${cvsPropertiesBranch#*,}; # R1_1_maintenance
	cvsPropertiesFile=${cvsPropertiesPath##*/}; # promoteToEclipse.query.properties
	subprojectName=${cvsPropertiesPath##*promoteToEclipse.}; subprojectName=${subprojectName%.properties}; # query
	#debug "\$cvsPropertiesPath=$cvsPropertiesPath"; debug "\$cvsPropertiesBranch=$cvsPropertiesBranch"; debug "\$cvsPropertiesFile=$cvsPropertiesFile"; debug "\$subprojectName=$subprojectName";
	debug "   -c $in [using $cvsPropertiesFile from $cvsPropertiesBranch]"; 
	olddir=`pwd`;
	cd /tmp;
	cvs -d :pserver:anonymous@dev.eclipse.org:/cvsroot/modeling -Q ex -r $cvsPropertiesBranch -d $tmp $cvsPropertiesPath
	if [ -r /tmp/$tmp/$cvsPropertiesFile ]; then 
		. /tmp/$tmp/$cvsPropertiesFile; 
		rm -fr /tmp/$tmp;
	else 
		echo "[start_cron] Properties file $cvsPropertiesPath not found in CVS for branch/tag $cvsPropertiesBranch. Exiting..."; 
		rm -fr /tmp/$tmp; exit 99; 
	fi; 
	
	if [[ ! $subprojectName ]]; then # if not set in properties file 
		subprojectName=${cvsPropertiesPath##*promoteToEclipse.}; subprojectName=${subprojectName%.properties}; # query
	fi
	cd $olddir
}

# Create local variable based on the input
debug " "
debug "[start_cron] Started `date +%H:%M:%S`. Executing with the following options:"
while [ "$#" -gt 0 ]; do
	case $1 in
		'-c')    loadCVSPropertiesFile $2; shift 1;;
		'-f')    propertiesFile=$2; debug "   $1 [using $propertiesFile]"; if [ -r $propertiesFile ]; then . $propertiesFile; else echo "[start_cron] Properties file $propertiesFile not found. Exiting..."; exit 99; fi; shift 1;;
		'-sub')  subprojectName=$2; debug "   $1 $2";
			# chain them together in order of priority: subproj specific one, default
			propertiesFiles=$propertiesFiles" ./promoteToEclipse."$subprojectName".properties "$defaultPropertiesFile; 
			loaded=0; for propertiesFile in $propertiesFiles; do if [ "$loaded" -eq 0 ] && [ -r $propertiesFile ]; then 
				debug "    [loading $propertiesFile ... " 1 "-n";
				cd $scriptsdir; . $propertiesFile; 
				debug "done]" 1;
				loaded=1; fi; done
			if [ "$loaded" -eq 0 ]; then echo "    [Can't load any of: $propertiesFiles. Exiting!]";exit 99; fi
			shift 1;;

		'-URL'|'-d')
			if [ "x$dependURL" != "x" ]; then dependURL="$dependURL "; fi
			dependURL=$dependURL"$2"; debug "   $1 $2"; shift 1;;
		'-a'|'-addSDK') addSDK="-addSDK $depsFile";  debug "   $1"; shift 0;;
		'-l'|'-listDeps')
			echo "Dependencies file is $depsFile:"
			cat $depsFile | grep -v "?file=" | egrep "[[:digit:]].[[:digit:]].[[:digit:]]|[[:digit:]]{8}|[[:digit:]]{4}|[[:digit:]]{2}|=";
			exit 1;
		shift 0;;
			
		'-regex')  regex=$2; debug "   $1 $2"; shift 1;;
		'-deps')   deps=$2; debug "   $1 $2"; shift 1;;
		'-days')   days=$2; debug "   $1 $2"; shift 1;;
		
		'-buildType')  buildType=$2; debug "   $1 $2"; shift 1;;
		'-cvsbranch')  cvsbranch=$2; debug "   $1 $2"; shift 1;;
		'-javaHome')   javaHomeOverride=$2; debug "   $1 $2"; shift 1;;
		'-buildAlias')        buildAlias="-buildAlias "$2;                debug "   $1 $2"; shift 1;;
		'-basebuilderBranch') basebuilderBranch="-basebuilderBranch "$2;  debug "   $1 $2"; shift 1;;
		'-projRelengRoot')    projRelengRoot="-projRelengRoot "$2;  	  debug "   $1 $2"; shift 1;;
		'-projRelengBranch')  projRelengBranch="-projRelengBranch "$2;    debug "   $1 $2"; shift 1;;

		'-debug')   		debug=$2; shift 1;;
		'-O'|'-depsOnly')   depsOnly=1; shift 0;;
		'-s'|'-searchCVS'|'-searchcvs') searchCVSModules=$2; debug "   $1 $2"; shift 1;;
		'-n'|'-noSearchCVS'|'-nosearchcvs') nosearchcvs=1; debug "   $1"; shift 0;;
		'-p'|'-preview') preview=1; debug "   $1"; shift 0;;
		'-timestamp') timestamp=$2; debug "   $1 $2"; shift 1;;
		*) args=$args" $1"; debug "   $1"; shift 0;;
	esac
	shift 1
done

if [[ ! $projectName ]] || [[ ! $subprojectName ]]; then
	usage;
fi
if [[ ! $deps ]] && [[ ! $regex ]] && [[ ! $dependURL ]] && [[ ! $depsOnly ]]; then
	usage;
fi

projectPath=modeling/$projectName/$subprojectName;
buildCommonFile=$webRoot/$projectPath/build/_common.php;
if [[ -f $buildCommonFile ]]; then
	parent="modeling";
else
	WARN="[start_cron] [1] can't find $buildCommonFile.";
	if [[ $projectName == "emf" ]]; then # try emft
		projectPath=modeling/emft/$subprojectName;
		buildCommonFile=$webRoot/$projectPath/build/_common.php;
	 	if [[ -f $buildCommonFile ]]; then
			parent="modeling";
		else
			echo $WARN;
			WARN="[start_cron] [2] can't find $buildCommonFile.";
			projectPath=$projectName;
		 	buildCommonFile=$webRoot/$projectName/build/_common.php;
		 	if [[ -f $buildCommonFile ]]; then
				parent="NONE";
			else
				echo $WARN;	echo "[start_cron] [3] can't find $buildCommonFile: must abort."; exit 1;
		 	fi
	 	fi
	else
		projectPath=$projectName;
		buildCommonFile=$webRoot/$projectPath/build/_common.php;
	 	if [[ -f $buildCommonFile ]]; then
			parent="NONE";
		else
			echo $WARN;	echo "[start_cron] [3] can't find $buildCommonFile: must abort."; exit 1;
	 	fi
	fi
fi

if [[ ! $basebuilderBranch ]]; then
	debug "Searching for BaseBuilderBranch in $buildCommonFile ... " 2 "-n";
	basebuilderBranch=$(cat $buildCommonFile | perl -pe "s#\?\>#echo \\\$options['BaseBuilderBranch']; \?\>#" | perl -pe "s/require/#require/" | php);
	if [[ $basebuilderBranch ]]; then basebuilderBranch="-basebuilderBranch $basebuilderBranch"; fi
	debug "  \$basebuilderBranch=$basebuilderBranch" 2;
fi

if [[ ! $projRelengRoot ]] && [[ $(grep "ProjRelengRoot" $buildCommonFile) ]]; then
	debug "Searching for ProjRelengRoot in $buildCommonFile ... " 2 "-n";
	projRelengRoot=$(cat $buildCommonFile | perl -pe "s#\?\>#echo \\\$options['ProjRelengRoot']; \?\>#" | perl -pe "s/require/#require/" | php);
	if [[ $projRelengRoot ]] && [[ $(echo $projRelengRoot | grep "cvs") ]]; then 
		projRelengRoot="-projRelengRoot $projRelengRoot"; 
		debug "  \$projRelengRoot=$projRelengRoot" 2;
	else
		projRelengRoot="";
	fi
fi

if [[ ! $regex ]] && [[ ! $deps ]] && [[ $(grep "\"regex\" => " $buildCommonFile) ]]; then
	debug "Searching for regex pattern in $buildCommonFile ... " 2 "-n";
	regexp=$(cat $buildCommonFile | perl -pe "s#\?\>#echo \\\$options['regex']; \?\>#" | perl -pe "s/require/#require/" | php);
	if [[ $regexp ]]; then regex="$regexp"; fi
	debug "  \$regex=$regex" 2;
fi
if [[ ! $regex ]] && [[ ! $deps ]]; then
	debug "[start_cron] [4] Warning! No -deps or -regex flag specified.";
	debug "[start_cron] [4] Could not load regex pattern from $buildCommonFile: must abort."; exit 1; 
fi
	
# 1. run parsecvs on the past 24hrs' range (runs at 10pm every night): see http://wiki.eclipse.org/index.php/Search_CVS#Database_Server
# 2. check results; if count greater than 0 in http://build.eclipse.org/modeling/searchcvs.php?q=project:+org.eclipse.$f+days:+7+branch:$cvsbranch\&totalonly, run a build

function querySearchCVS()
{
	query=$1; debug "  $query ... " 0 "-n";
	if [[ $nosearchcvs == 1 ]]; then
		deltasThis=1; debug "skipped.";
	else
		deltasThis="`wget -q -O - $query`";
		if [[ $(echo $deltasThis | egrep '[^0-9]') ]]; then
			echo "ERROR: $deltasThis";
			exit 1
		fi
		debug "$deltasThis found.";
	fi
}

deltas=0;
deltasThis=0;

if [[ $dependURL != "" ]]; then # if passed values from the feedWatch, do a build;
	deltas=1;
else # else do a build only if there's something new in Search CVS 
	if [[ ! $days ]]; then # defaults
		# for nightly, check last day; for all others, check week
		if [[ $buildType == "N" ]]; then days=1; else days=7; fi
	fi

	if [[ $searchCVSModules == "" ]]; then
		if [[ $subprojectName == "emf" ]]; then 
			searchCVSModules="emf.emf,emf.ecore.sdo,mdt.xsd,emf.releng"; # special case default for EMF
		else
			searchCVSModules=$projectName"."$subprojectName","$projectName"."$subprojectName".releng"; # all others default to proj.sub,proj.sub.releng
		fi
		debug "Search for deltas in default modules: "$searchCVSModules;
	else
		debug "Search for deltas in these modules: "$searchCVSModules;
	fi
	searchcvsUnique=( $(echo $searchCVSModules | perl -pe "s#,# #g") );
	i=0;
	while [[ $i -lt ${#searchcvsUnique[@]} ]]; do
		p=${searchcvsUnique[$i]}; p=${p%%.*}; # project = emf
		s=${searchcvsUnique[$i]}; s=${s#*.}; # subproject = query.releng
		if [[ $p == "emf" ]] || [[ $p == "emft" ]]; then
			p="emf";
			if [[ $s != "emf" ]]; then
				s="emf."$s; # don't do org.eclipse.emf.emf
			fi
		fi
		querySearchCVS "http://build.eclipse.org/modeling/searchcvs.php?q=file:org.eclipse.${p}%2Forg.eclipse.${s}%2F+days:$days+branch:$cvsbranch&totalonly"; deltas=$((deltas + deltasThis));
		i=$((i + 1));
	done
fi

debug "  \$deltas=$deltas" 2

# holds all available names/URLs/dates
declare -a depNames=();
declare -a depURLs=();
declare -a depDates=();
declare -a depTypes=();

# holds a unique array of dependency names & URLs
declare -a depNamesUnique=();
declare -a depURLsLatest=();

#	eg., print_r depNamesUnique ${depNamesUnique[@]} or print_r depURLsLatest ${depURLsLatest[@]} 
function print_r()
{
	local array_name; array_name=$1; shift 1;
	local array; array_items=( `echo "$*"` );
	i=0;
	while [[ $i -lt ${#array_items[@]} ]]; do
		echo $array_name[$i]=${array_items[$i]};
		i=$((i + 1));
	done
}

function loadDependencies()
{
	if [[ $regex ]]; then
		debug "Using regex=\"$regex\" ..."
		lines=$(cat $depsFile | egrep "$regex");
		c=0;
		for l in $lines; do #  01eclipse=http://download.eclipse.org/eclipse/downloads/drops/I20070920-0936/eclipse-SDK-I20070920-0936-linux-gtk.tar.gz
			dURL=${l##*=};
			if [[ ${dURL:0:1} != "/" ]] && [[ ${dURL:0:1} != "[" ]]; then # filter bad URLs & header rows
				dname=${l%%=*}; dname=${dname:2}; 
				dtype=$(echo $dURL | perl -pe "s#.+drops/([IMRNS]|\d+\.\d+\.\d+/[IMRNS]).+#\1#g"); dtype=${dtype##*/}; # debug "got $dtype ($dtype)" 
				ddate=$(echo $dURL | perl -pe "s#.+(${dtype}|-)((\d{8})-*(\d{4,6}))[^\d]+.+#\3\4#g"); #debug "got $dname ($ddate)" 
			else
				continue;
			fi
			i=0;
			ddateIsNew=1;
			while [[ $i -lt ${#depDates[@]} ]]; do
				if [[ ${depDates[$i]} == $ddate ]] && [[ ${depNames[$i]} == $dname ]]; then
					# check if depdate already exists; if so, replace if type is greater
					if [[ ${depTypes[$i]} == "I" ]] || [[ ${depTypes[$i]} == "M" ]]; then
						if [[ $dtype == "S" ]] || [[ $dtype == "R" ]]; then
							debug "Multiple dependencies with same name & date found. Replace ${depNames[$i]}:${depTypes[$i]}:${depDates[$i]} with $dname:$dtype:$ddate" 2;
							depNames[$i]=$dname; depURLs[$i]=$dURL; depDates[$i]=$ddate; depTypes[$i]=$dtype; # replace M with S or R
						fi
					elif [[ ${depTypes[$i]} == "S" ]]; then
						if [[ $dtype == "R" ]]; then
							debug "Multiple dependencies with same name & date found. Replace ${depNames[$i]}:${depTypes[$i]}:${depDates[$i]} with $dname:$dtype:$ddate" 2;
							depNames[$i]=$dname; depURLs[$i]=$dURL; depDates[$i]=$ddate; depTypes[$i]=$dtype; # replace S with R
						fi
					fi
					ddateIsNew=0; 
				fi
				i=$((i + 1));
			done
			if [[ $ddateIsNew -gt 0 ]]; then # don't add it again if we already have this datestamp
				depNames[$c]=$dname; depURLs[$c]=$dURL; depDates[$c]=$ddate; depTypes[$c]=$dtype; 
				(( c++ ));
			fi
		done
		
		tmpfile=$(mktemp);
		i=0;
		while [[ $i -lt ${#depNames[@]} ]]; do
			echo ${depNames[$i]} >> $tmpfile
			i=$((i + 1));
		done
		depNamesUnique=( $(cat $tmpfile | sort | uniq) );
		rm -fr $tmpfile;
		debug "Got ${#depNamesUnique[@]} unique dependency types" 1
		
	elif [[ $deps ]]; then # convert csv to space-sep'd list; work on each one
		debug "Using deps=$deps ..."
		depNamesUnique=( $(echo $deps | perl -pe "s#,# #g") );
		c=0;
		i=0;
		while [[ $i -lt ${#depNamesUnique[@]} ]]; do
			debug "Searching for ${depNamesUnique[$i]} dependencies ..." 2;
			lines=$(cat $depsFile | egrep "[0-9][0-9]${depNamesUnique[$i]}="); #  01eclipse=http://download.eclipse.org/eclipse/downloads/drops/I20070920-0936/eclipse-SDK-I20070920-0936-linux-gtk.tar.gz
			for l in $lines; do
				if [[ $l ]]; then
					dURL=${l##*=}; 
					if [[ ${dURL:0:1} != "/" ]]; then # filter bad URLs
						dname=${l%%=*}; dname=${dname:2}; 
						dtype=$(echo $dURL | perl -pe "s#.+drops/([IMRNS]|\d+\.\d+\.\d+/[IMRNS]).+#\1#g"); dtype=${dtype##*/}; # debug "got $dtype ($dtype)" 
						ddate=$(echo $dURL | perl -pe "s#.+(${dtype}|-)((\d{8})-*(\d{4,6}))[^\d]+.+#\3\4#g"); #debug "got $dname ($ddate)" 
					fi
					depNames[$c]=$dname; depURLs[$c]=$dURL; depDates[$c]=$ddate; depTypes[$i]=$dtype; # replace S with R
					(( c++ ));
				fi
			done
			i=$((i + 1));
		done
	fi
	
	if  [[ $debug -ge 2 ]]; then
		debug "Loaded these dependencies ($brown\$depDates$norm) $red\$depNames$norm = $yellow\$depURLs${norm}:" 2;
		i=0;
		while [[ $i -lt ${#depNames[@]} ]]; do
			debug "  ("$brown${depDates[$i]}$norm") "$red${depNames[$i]}$norm" = "$yellow${depURLs[$i]}$norm 2; 
			i=$((i + 1));
		done
	fi
}

function loadLatestDependencies()
{
	debug "Calculate latest dependencies..."
	i=0;
	while [[ $i -lt ${#depNamesUnique[@]} ]]; do
		j=0;
		latestDate=0;
		debug "  $red${depNamesUnique[$i]}$norm ($i):" 1 "-n"; debug "" 2;
		depURLsLatest[$i]="."; # ensure any skipped entries will still line up correctly
		while [[ $j -lt ${#depNames[@]} ]]; do
			d=${depDates[$j]};
			dd=1${depDates[$j]:2:6}; # use only YYMMDD, but with "1" prefix so that it doesn't look like an octal #
			dt=1${depDates[$j]:8}; # use hhmm, but with "1" prefix so that it doesn't look like an octal # 
			ld=1${latestDate:2:6};
			lt=1${latestDate:8};
			debug "     diff $dd-$dt vs. $ld-$lt ... " 3 "-n"
			# if dates match, add in time so that one will be greater than the other 
			if [[ $dd -eq $ld ]]; then 
				dd=$((dd + dt)); 
				ld=$((ld + lt)); 
				debug "diff $dd vs. $ld ... " 3
			else 
				debug "" 3 
			fi
			if [[ $dd -gt $ld ]] && [[ ${depNames[$j]} == ${depNamesUnique[$i]} ]]; then 
				latestDate=${depDates[$j]};
				depURLsLatest[$i]=${depURLs[$j]};
				debug "  ($brown${depDates[$j]}$norm) = $yellow${depURLsLatest[$i]}$norm" 2;
			fi
			j=$((j + 1));
		done
		#latestDates[$i]=$latestDate;
		#debug "got (${depNamesUnique[$i]}) latestDates[$i] = ${latestDates[$i]}"; debug ""
		debug "        (${brown}latest$norm) =" 2 "-n"; debug " $yellow${depURLsLatest[$i]}$norm" 1
		i=$((i + 1));
	done
}

# return "-URL http://...1 -URL http://...2 ..."
function buildCommandURLs()
{
	if [[ $dependURL ]]; then
		for dep in $dependURL; do
			depURL=${dep##*=};
			depName=${dep%%=*};
			if [[ $depName != $depURL ]]; then
				debug "Using $depName URL $depURL ... " 0 "-n"
				foundDep=0;
				i=0;
				while [[ $i -lt ${#depNamesUnique[@]} ]]; do
					if [[ ${depNamesUnique[$i]} == $depName ]]; then
						depURLsLatest[$i]=$depURL;
						debug "URL overridden."
						foundDep=1;
					fi
					i=$((i + 1));
				done
				if [[ $foundDep -lt 1 ]]; then # add it to the list as it wasn't one to be replaced
					debug "URL added."
					depNamesUnique[${#depNamesUnique[@]}]=$depName;
					depURLsLatest[${#depURLsLatest[@]}]=$depURL;
				fi
			else
				debug "*** WARNING: Can't use -d value (no dependency type specified!) ***"
				debug "*** -d values must be type=URL ***" 
				debug "*** $dep ***"
			fi
			
		done
	fi
	
	debug "Assembling \$command with -URL flags ... " 2 "-n"
	i=0;
	while [[ $i -lt ${#depURLsLatest[@]} ]]; do
		if  [[ ${depURLsLatest[$i]} == "." ]]; then
			debug ""; debug "*** WARNING: no valid URL found for ${depNamesUnique[$i]}. Skipping dependency and hoping for the best... ***" 0 "-n";
		elif [[ ${depURLsLatest[$i]} != "" ]]; then
			command=$command" -URL ${depURLsLatest[$i]}"
		fi
		i=$((i + 1));
	done
}

function showDepsOnly ()
{
	i=0;
	while [[ $i -lt ${#depURLsLatest[@]} ]]; do
		if  [[ ${depURLsLatest[$i]} == "." ]]; then
			debug ""; debug "*** WARNING: no valid URL found for ${depNamesUnique[$i]}. Skipping dependency and hoping for the best... ***" 0 "-n";
		elif [[ ${depURLsLatest[$i]} != "" ]]; then
			echo ${depNamesUnique[$i]}=${depURLsLatest[$i]};
		fi
		i=$((i + 1));
	done
}

if [[ $deltas ]] && [[ $deltas -gt 0 ]]; then

	# 3a. get branch (assume $cvsbranch), need numerical value, eg., 2.1.0
	branch=`cat $buildCommonFile | grep -v "#" | grep "=$cvsbranch" | head -1`;
	version=${branch%%=*}; version=${version##*\"};
	branch=$version;
	debug "  \$version=$version" 2
	
	if [[ $javaHomeOverride == "" ]] || [[ ! -d $javaHomeOverride ]]; then
		# 3b. get javaHome 
		javaHomes=`cat $buildCommonFile | grep -v "#" | grep "=$cvsbranch"`;
		for javaHome in $javaHomes; do
			javaHome=${javaHome#*,}; javaHome=${javaHome%\"*};
			if [[ -d $javaHome ]]; then break; fi
		done
		debug "  \$javaHome=$javaHome" 2
	elif [[ $javaHomeOverride != "" ]] && [[ -d $javaHomeOverride ]]; then
		javaHome=$javaHomeOverride;
	fi	
	
	# 4. get dependencies for regex or deps list
	loadDependencies;
	loadLatestDependencies;
	if [[ $depsOnly -eq 1 ]]; then
		showDepsOnly;
		exit;
	fi
	
	# 5. get timestamp to use
	if [[ ! $timestamp ]]; then 
		timestamp=`date +%Y%m%d%H%M`;
	fi

	if [[ $preview -ne 1 ]]; then
		# 6. create folder
		mkdir -p $writableBuildRoot/build/$projectPath/downloads/drops/$branch/$buildType$timestamp/eclipse ;
	fi
	
	# 7. assemble instructions for start.sh
	logfile=$writableBuildRoot/build/$projectPath/downloads/drops/$branch/$buildType$timestamp/buildlog.txt;
	command="$writableBuildRoot/build/modeling/scripts/start.sh"
	# when we're building EMFT but it's actually in EMF cvs repo
	if [[ $projectName == "emft" ]]; then projectNameActual="emf"; else projectNameActual=$projectName; fi
	command=$command" -proj $projectNameActual -sub $subprojectName"
	command=$command" -version $version -branch $cvsbranch"
	buildCommandURLs;
	command=$command" -antTarget run"
	if [[ $subprojectName == "emf" ]]; then # use -tagBuild true/false instead
		if [[ $buildType == "N" ]]; then command=$command" -tagBuild false"; else command=$command" -tagBuild true"; fi
	else
		command=$command" -mapfileRule use-false"; # TODO: hook in value from _common.php?
	fi
	command=$command" -writableBuildRoot $writableBuildRoot";
	command=$command" -buildType $buildType \
	 -javaHome $javaHome \
	 -downloadsDir $writableBuildRoot/build/downloads \
	 -buildDir $writableBuildRoot/build/$projectPath/downloads/drops/$branch/$buildType$timestamp \
	 -buildTimestamp $timestamp \
	 $buildAlias $basebuilderBranch $projRelengBranch $projRelengRoot $addSDK $args";
	
	# 8. echo instructions
	echo " ";
	echo $command | perl -pe "s/ -/\n  -/g";
	echo "  > $logfile";
	echo " ";
	
	if [[ $preview -ne 1 ]]; then
		# 9. log instuctions
		echo "[nightly] Starting automatic $projectName $subprojectName $buildType build at `date +%Y%m%d\ %H:%M:%S`" > $logfile;
		echo " " >> $logfile;
		echo $command | perl -pe "s/ -/\n  -/g" >> $logfile;
		echo " " >> $logfile;
		
		# 10. execute instructions (start build)
		$command 1>> $logfile 2>> $logfile &
	else
		echo "*** PREVIEW ONLY. No build started. ***";
	fi
	
else
	if [[ $subprojectName == "emf" ]]; then 
		echo "Nothing to do! No changes in CVS found in past $days day(s) for $subprojectName.";
	else
		echo "Nothing to do! No changes in CVS found in past $days day(s) for $projectName $subprojectName.";
	fi
fi
